<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: number.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: number.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * The number module provides a collection of utility methods for manipulating numbers and allows you to choosing
 * user-defined patterns for number formatting.
 *
 * Number formats are specified by number pattern strings. The pattern strings are designed to
 * conform to java.text.DecimalFormat.
 *
 * ##### Usage
 *    expect(number.format(1234)).to.equal("1234");
 *
 *    expect(number.format(1234.567, "##,##0.##")).to.equal("1,234.57");
 *    expect(number.format(-1234.567, "##,##0.##")).to.equal("-1,234.57");
 *
 *    expect(number.format(1234.5, "##,##0.00")).to.equal("1,234.50");
 *
 *    expect(number.format(1234.5, "$##,##0.00")).to.equal("$1,234.50");
 *
 *    expect(number.format(0.12345, "#0.##%")).to.equal("12.35%");
 *
 *    expect(number.parse("1234")).to.equal(1234);
 *
 *    expect(number.parse("1,234.56", "##,##0.##")).to.equal(1234.56);
 *    expect(number.parse("-1234.56", "##,##0.##")).to.equal(-1234.56);
 *
 *    expect(number.parse(".1", "##,###.##")).to.equal(0.1);
 *
 *    expect(number.parse("$1,234.50", "$##,##0.00")).to.equal(1234.5);
 *
 * @module number
 * @author  Jason Lin
 * @since   1.0
 */
define(['underscore', 'uweaver/string', 'uweaver/exception/InvalidFormatException',
    'uweaver/exception/UnsupportedTypeException'], function(_, string, InvalidFormatException, UnsupportedTypeException) {

    var DECIMALSEPARATOR = ".", GROUPINGSEPARATOR = ",", CURRENCYSIGN = "$";

    /**
     * The method parses a string representation of a number using a specified pattern and returns the number.
     *
     * ##### Usage
     *    expect(number.parse("1234")).to.equal(1234);
     *
     *    expect(number.parse("1,234", "##,##0.##")).to.equal(1234);
     *    expect(number.parse("1,234.5", "##,##0.##")).to.equal(1234.5);
     *    expect(number.parse("1,234.56", "##,##0.##")).to.equal(1234.56);
     *    expect(number.parse("-1234.56", "##,##0.##")).to.equal(-1234.56);
     *
     *    expect(number.parse("", "##,###.##")).to.equal(0);
     *    expect(number.parse(".1", "##,###.##")).to.equal(0.1);
     *
     *    expect(number.parse(".10", "##,###.00")).to.equal(0.1);
     *
     *    expect(number.parse("$1,234.50", "$##,##0.00")).to.equal(1234.5);
     *
     *    expect(number.parse("($1,234.50)", "$##,##0.00;($##,##0.00)")).to.equal(-1234.5);
     *
     * @memberof module:number
     * @param {String} text - the text to convert.
     * @param {String} [pattern] - specify a number pattern to parse the text.
     * @param {Object} [options] - specify a set of symbols (such as the decimal separator, the grouping separator, and so on).
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {Number}
     */
    function parse(text, pattern, options) {
        if(text===null||text===undefined) {
            return null;
        } else if(!_.isString(text)) {
            throw new UnsupportedTypeException({
                type: typeof text,
                supportedTypes: ['String']
            });
        } else if(text.length===0) {
            return null;
        }


        var compliant = test(text, pattern, options);
        if(!compliant) {
            throw new InvalidFormatException({
                entity: text,
                format: pattern
            });
        }

        options || (options = {});

        var decimalSeparator = options.decimalSeparator || DECIMALSEPARATOR,
            groupingSeparator = options.groupingSeparator || GROUPINGSEPARATOR;

        var n = new Number(text.replace(groupingSeparator, '').replace(decimalSeparator, '.').replace(/[^0-9\.]/g, ''));

        if(compliant===2) n = n * -1;

        return n.valueOf();

    }


    /**
     * The method formats a number to a string representation using the specified pattern.
     *
     * ##### Usage
     *    expect(number.format(1234)).to.equal("1234");
     *
     *    expect(number.format(0, "##,##0.##")).to.equal("0");
     *    expect(number.format(1234, "##,##0.##")).to.equal("1,234");
     *    expect(number.format(1234.56, "##,##0.##")).to.equal("1,234.56");
     *    expect(number.format(1234.567, "##,##0.##")).to.equal("1,234.57");
     *    expect(number.format(-1234.567, "##,##0.##")).to.equal("-1,234.57");
     *
     *    expect(number.format(0, "##,##0.00")).to.equal("0.00");
     *    expect(number.format(1234.5, "##,##0.00")).to.equal("1,234.50");
     *    expect(number.format(0.1, "##,###.00")).to.equal(".10");
     *
     *    expect(number.format(0, "##,###.##")).to.equal("");
     *    expect(number.format(0.1, "##,###.##")).to.equal(".1");
     *
     *    expect(number.format(1234.5, "$##,##0.00")).to.equal("$1,234.50");
     *
     *    expect(number.format(-1,234.5, "$##,##0.00;($##,##0.00)")).to.equal("($1,234.50)");
     *
     * @memberof module:number
     * @param {Number} value - the number to format.
     * @param {String} [pattern] - specify a date pattern to format the value.
     * @param {Object} [options] - specify a set of symbols (such as the decimal separator, the grouping separator, and so on).
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {String}
     */
    function format(value, pattern, options) {
        if(value===null||value===undefined) {
            return null;
        } else if(!_.isNumber(value)) {
            throw new UnsupportedTypeException({
                type: typeof text,
                supportedTypes: ["Number"]
            });
        }

        if(!pattern) return value.toString();

        options || (options = {});

        var decimalSeparator = options.decimalSeparator || DECIMALSEPARATOR,
            groupingSeparator = options.groupingSeparator || GROUPINGSEPARATOR;

        var patterns = translate(pattern, decimalSeparator, groupingSeparator).split(';');
        var positive = patterns[0];
        var negative = (patterns.length>1) ? patterns[1] : '-' + positive;

        hasPercentage(positive) &amp;&amp; (value = value * 100);

        var scale = calScale(value, positive);
        var groupingSize = calGroupingSize(positive);

        var result = Math.abs(value).toFixed(scale);

        if(value>-1 &amp;&amp; value&lt;1 &amp;&amp; parseZero(positive)==="#") {
            result = result.substring(1);
        }

        if(groupingSize > 0) {
            var expr = '(\\d)(?=(\\d{' + groupingSize + '})+(\\.|$))';
            var regExp = new RegExp(expr, 'g');
            result = result.replace(regExp, '$1,');
        }

        var template = (value >= 0) ? positive : negative;

        var patternRegExp = new RegExp(genPatternExpr(groupingSize, scale));

        result = template.replace(patternRegExp, result);

        return result.replace(/[,\.]/, function(match) {
            if(match==='.') {
                return decimalSeparator;
            } else if(match===',') {
                return groupingSeparator;
            }
        });
    }

    function hasPercentage(pattern) {
        return /(^%|%$)/.test(pattern);
    }
    /**
     *
     * The method calculates the grouping size.
     *
     * Extract the string of # &amp; 0 between the decimal separator &amp; the grouping separator. The size of the string is the
     * grouping size.
     *
     * @private
     * @param {String} pattern
     * @returns {number}
     */

    function calGroupingSize(pattern) {
        var matches = /,[0#]+(\.|$)/.exec(pattern);

        if(!matches) return 0;

        return _.first(matches).replace(/[,.]/g, '').length;
    }

    /**
     *
     * The method calculates the scale.
     *
     * @private
     * @param {number|String} value
     * @param {String} pattern
     * @returns {number}
     */

    function calScale(value, pattern) {
        var text = value.toString();

        // calculate the scale specified by pattern.
        var matches = /\.[0#]+/.exec(pattern);
        var pScale = (matches) ? _.first(matches).length-1 : 0;

        // calculate the scale of the value.
        matches = /\.\d+/.exec(text);
        var vScale = (matches) ? _.first(matches).length-1 : 0;

        if(pScale &lt;= vScale) return pScale;

        // substitute with zero.
        matches = /\.[0]+/.exec(pattern);
        pScale = (matches) ? _.first(matches).length-1 : 0;

        return Math.max(vScale, pScale);
    }

    /**
     *
     */
    function parseZero(pattern) {
        var matches = /[0#]{1}(\.|$|%)/.exec(pattern);

        return (matches) ? _.first(matches).charAt(0) : '#';


    }

    /**
     *
     * The method converts a value to a number using the specified pattern.
     *
     * ##### Usage
     *    expect(number.convert(1234)).to.equal(1234);
     *    expect(number.convert("1234")).to.equal(1234);
     *    expect(number.convert("1,234", "##,###")).to.equal(1234);
     *    expect(number.convert("$1,234.50", "$##,##0.00")).to.equal(1234.5);
     *    expect(number.convert("($1,234.50)", "$##,##0.00;($##,##0.00)")).to.equal(-1234.5);
     *
     * @memberof module:number
     * @param {String|Number} value - the value to convert.
     * @param {String} [pattern] - specify a number pattern to parse the text.
     * @param {Object} [options] - specify a set of symbols (such as the decimal separator, the grouping separator, and so on).
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {Number}
     */
    function convert(value, pattern, options) {
        if(value===undefined||value===null) return value;
        if(_.isNumber(value)) {
            return value;
        } else if(_.isString(value)) {
            if(value.length===0) return null;
            return parse(value, pattern, options);
        } else {
            throw new UnsupportedTypeException({
                type: typeof value,
                supportedTypes: ["String", "Number"]
            });
        }
    }

    /**
     *
     * The method tests if a string representation is a number using the specified pattern.
     *
     * @memberof module:number
     * @param {String} text - the text to check.
     * @param {String} [pattern] - specify a number pattern to test the text.
     * @param {Object} [options] - specify a set of symbols (such as the decimal separator, the grouping separator, and so on).
     * @param {String} [options.decimalSeparator="."] - decimal separator.
     * @param {String} [options.groupingSeparator=","] - grouping separator.
     * @returns {Integer} - 0 => not a number, 1 => positive number, 2 => negative number.
     */
    function test(text, pattern, options) {
        if(!_.isString(text)) {
            throw new UnsupportedTypeException({
                type: typeof text,
                supportedTypes: ['String']
            });
        }

        if(!pattern) {
            if(!/[^0-9\.]/.test(text)) {
                return 1;
            } else if(!/[^0-9\.\-]/.test(text)) {
                return 2;
            } else {
                return 0;
            }
        }

        options || (options = {});

        var decimalSeparator = options.decimalSeparator || DECIMALSEPARATOR,
            groupingSeparator = options.groupingSeparator || GROUPINGSEPARATOR;

        var patterns = translate(pattern, decimalSeparator, groupingSeparator).split(';');
        var positive = patterns[0];
        var negative = (patterns.length>1) ? patterns[1] : '-' + positive;

        var scale = calScale(text, positive);
        var zero = parseZero(positive);
        var groupingSize = calGroupingSize(positive);

        var numberExpr = genNumberExpr(groupingSize, scale, zero);
        var patternRegExp = new RegExp(genPatternExpr(groupingSize, scale));

        var regExp = new RegExp(escapeSpecialChar(positive).replace(patternRegExp, numberExpr));
        var matches = regExp.exec(text);
        if(matches &amp;&amp; matches[0]==text) return 1;

        regExp = new RegExp(escapeSpecialChar(negative).replace(patternRegExp, numberExpr));
        var matches = regExp.exec(text);
        if(matches &amp;&amp; matches[0]==text) return 2;

        return 0;
    }

    /**
     *
     * translate the localized pattern to the standard pattern.
     *
     * @private
     * @param pattern
     */
    function translate(pattern, decimalSeparator, groupingSeparator) {
        var regExp = new RegExp("[\\" + decimalSeparator + "\\" + groupingSeparator + "]", 'g');
        return pattern.replace(regExp, function(match) {
            if(match===decimalSeparator) {
                return '.';
            } else if(match===groupingSeparator) {
                return ',';
            }
        });
    }

    function escapeSpecialChar(text) {
        return text.replace(/[\(\$\)]/g, "\\$&amp;");
    }

    function genNumberExpr(groupingSize, scale, zero) {
        var expr;

        var minWholdDigits = (zero==='0') ? 1 : 0;

        if(groupingSize>0) {
            expr = '([0-9]{' + minWholdDigits + ',' + (groupingSize - 1) + '})+(,[0-9]{3})*';
        } else {
            expr = '[0-9]{' + minWholdDigits + ',}';
        }

        if(scale>0) {
            expr = expr + '\\.([0-9]{' + scale + '})';
        }

        return expr;
    }

    function genPatternExpr(groupingSize, scale) {
        var expr;

        if(groupingSize>0) {
            expr = '[#0,]*,[#0]{' + groupingSize + '}';
        } else {
            expr = '[#0]*';
        }

        expr = expr + '(\\.[#0]*)?';

        return expr;
    }

    return {
        parse: parse,
        format: format,
        convert: convert,
        test: test
    };
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
